﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using IDAL;
using Models;
using System.Data;
using System.Data.SqlClient;

namespace DAL.SQLServer
{
    public class StudentService : IStudentService
    {
        public List<Student> GetStudentsByClassId(int classId)
        {
            StringBuilder sqlBuilder = new StringBuilder("select StudentId,StudentName,Gender,StudentIdNo,Birthday,PhoneNumber,ClassName,Students.ClassId from Students ");
            sqlBuilder.Append("inner join StudentClass on StudentClass.ClassId=Students.ClassId ");
            if (classId >= 0)//当==-1，说明是选的全部班级，则不需要筛选
                sqlBuilder.Append($"where Students.ClassId={classId} ");
            List<Student> stuList = new List<Student>();
            SqlDataReader objReader = null;
            try
            {
                objReader = SQLHelper.GetReader(sqlBuilder.ToString());
                while (objReader.Read())
                {
                    stuList.Add(new Student
                    {
                        StudentId = Convert.ToInt32(objReader["StudentId"]),
                        StudentName = objReader["StudentName"].ToString(),
                        Gender = objReader["Gender"].ToString(),
                        StudentIdNo = objReader["StudentIdNo"].ToString(),
                        Birthday = Convert.ToDateTime(objReader["Birthday"]),
                        PhoneNumber = objReader["PhoneNumber"].ToString(),
                        ClassName = objReader["ClassName"].ToString(),                       
                        ClassId = Convert.ToInt32(objReader["ClassId"]),                        
                    });
                }
                return stuList;
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                objReader.Close();
            }
        }
    }
}
